/* ZkwuL by Massena */
/* Optimisation and rewrite thanks to KikooDX */

#include <gint/display.h>
#include <gint/keyboard.h>
#include "main.h"

Vec2 search(tile_t x, tile_t level[16][16]) {
	/* Search for x in a given matrix. */
	/* If x is found, return it coordinates */
	Vec2 coordinates = {0, 0};
	for(int m = 0; m < LEVEL_SIZE; ++m) {
			for(int n = 0; n < LEVEL_SIZE; ++n) {
				if(level[m][n] == x) {
					/* idk why m and n are inversed but it works kek */
					coordinates.x = n * 12;
					coordinates.y = m * 12;
					return coordinates;
				}
			}
		}
	return coordinates;
}

int collide_pixel(Vec2 pos, tile_t obj, tile_t level[LEVEL_SIZE][LEVEL_SIZE]) {
	/* Check if there's something in (x, y) */
	if(obj == level[pos.y / TILE_SIZE][pos.x / TILE_SIZE]) {
		return 1;
	}
	else {
		return 0;
	}
}

int collide(Vec2 pos, int h, tile_t obj, tile_t level[LEVEL_SIZE][LEVEL_SIZE]) {
	/* tl = top left */
	/* br = bottom right */
	const Vec2 pos_tl = (Vec2){pos.x + h, pos.y + h};
	const Vec2 pos_br = (Vec2){pos.x + TILE_SIZE - h - 1, pos.y + TILE_SIZE - h - 1};
	/* Check if there's something in */
	/* the square (x + 1, y + 1, x + 11, y + 11) */
	/* The size of the hitbox changes with h */
	if(collide_pixel(pos_tl, obj, level) ||
	   collide_pixel(pos_br, obj, level) ||
	   collide_pixel((Vec2){pos_tl.x, pos_br.y}, obj, level) ||
	   collide_pixel((Vec2){pos_br.x, pos_tl.y}, obj, level))
	{
		return 1;
	}
	return 0;
}

Player level_reset(Player player, tile_t level[LEVEL_SIZE][LEVEL_SIZE]) {
	player.spawn = search(1, level);
	player.pos = player.spawn;
	return player;
}

int main(void) {
	extern bopti_image_t img_player;
	extern bopti_image_t img_wall;
	extern bopti_image_t img_spike;
	extern bopti_image_t img_end;

	extern tile_t level[LEVEL_NB][LEVEL_SIZE][LEVEL_SIZE];

	int running = 1;
	int timer = 0; /* lol */
	int lvl = 0;

	/* player */
	Player player = {
		.pos = {0, 0},
		.spawn = {0, 0}
	};
	
	player = level_reset(player, level[lvl]);

	/* main loop */
	while(running) {

		dclear(C_BLACK);

		/* drawing the level */
		for(int m = 0; m < LEVEL_SIZE; ++m) {
			for(int n = 0; n < LEVEL_SIZE; ++n) {
				switch(level[lvl][n][m]) {
					case 2:
						/* walls */
						dimage(m * TILE_SIZE, n * TILE_SIZE, &img_wall);
						break;
					case 3:
						/* end ring */
						dsubimage(m * TILE_SIZE, n * TILE_SIZE, &img_end,
							((timer / 30) % 4) * 12, 0, 12, 12, 0);
						break;
					case 4:
						/* spikes */
						dimage(m * TILE_SIZE, n * TILE_SIZE, &img_spike);
						break;
						
				}
			}
		}

		/* drawing the player */
		dimage(player.pos.x, player.pos.y, &img_player);

		dupdate();

		Vec2 mov = {
			.x = keydown(KEY_RIGHT) - keydown(KEY_LEFT),
			.y = keydown(KEY_DOWN) - keydown(KEY_UP)
		};
		clearevents();

		/* trying to move the player >w< */
		if(!collide((Vec2){player.pos.x + mov.x, player.pos.y}, 1, 2, level[lvl])) {
			player.pos.x += mov.x;
		}

		if(!collide((Vec2){player.pos.x, player.pos.y + mov.y}, 1, 2, level[lvl])) {
			player.pos.y += mov.y;
		}

		/* d i e */
		if(collide(player.pos, 2, 4, level[lvl])) {
			player = level_reset(player, level[lvl]);
		}

		if(keydown(KEY_EXIT)) {
			running = 0;
		}

		if(collide(player.pos, 0, 3, level[lvl])) {
			if(lvl != LEVEL_NB - 1) { 
				player = level_reset(player, level[lvl]);
				++lvl;
			}
			else {
				running = 0;
			}
		}

		++timer; /* lol^2 */
	}

	return 1;
}
